{
          
                
              The DoorKit!
              
             
The BBS Door Development Kit By The People - For The People!

              
            
               ͻ ͻ ͻ    ͻ ͻ
                    ˼ ͹ ͼ ͹     ͻ
                   ͼ          ͼ ͼ
   }
{$I DEFINES.INC}
UNIT MAX_CHAT;

INTERFACE

PROCEDURE StartUp;

IMPLEMENTATION

{$IFNDEF LocalMAX}
USES _EXIT,CRT,DOS,TDK_VARS,ANSIUNIT,MAX_UNIT,DOORKIT1,DOORKIT2,DOORKIT3;{
^ Use this for: No Local SVGA Graphics / With Comm Routines.}
{$ELSE}
USES _EXIT,CRT,DOS,TDK_VARS,DOORKIT2,MAXUNITG;{
^ Use this for: With Local SVGA Graphics / No Comm Routines.}
{$ENDIF}

TYPE Chat_File = RECORD
     UserName  : STRING[30];
     Online    : BOOLEAN;
     Channel   : WORD;
     Node      : WORD;
     Message   : STRING[45];
     Flags     : ARRAY[0..999] OF BYTE;
     END;

TYPE Msg_Info  = RECORD
     UserName  : STRING[30];
     Message   : STRING[45];
     Channel   : INTEGER;
     END;

TYPE MArray    = ARRAY[1..15] OF Msg_Info;

VAR
  Chat   : Chat_File;
  M      : ^MArray;
  Name   : STRING[30];
  Msg    : STRING[45];
  OnLine : BOOLEAN;
  Chan   : INTEGER;
  Last   : BYTE;

PROCEDURE SystemScreen(Screen : STRING);
VAR
  F     : TEXT;
  St    : STRING;
  Ext   : STRING[4];
  Start : BOOLEAN;
BEGIN
  IF NOT FExist('MAXCHAT.SCR') THEN BEGIN
    ErrLevel := 6;
    HALT(ErrLevel);
  END;
  IF Graphics = MAX THEN Ext := '.MAX' ELSE Ext := '.ANS';
  IF Graphics = MAX THEN MaxCommand('');
  Start  := FALSE;
  Screen := AllCaps(Screen) + Ext;
{$IFNDEF LocalMAX}
  HideCursor;
{$ENDIF}
  ASSIGN(F,'MAXCHAT.SCR');
  RESET(F);
  WHILE NOT EOF(F) DO BEGIN
    READLN(F,St);
    IF Graphics = MAX THEN St := StripBoth(St,' ');
    IF (Start) AND (St = #2#2) THEN BEGIN
      CLOSE(F);
{$IFNDEF LocalMAX}
      CurColor := TextAttr;
      ShowCursor;
{$ENDIF}
      EXIT;
    END;
    IF Start THEN BEGIN
      St := CvtVars(St);
      CASE Graphics OF
{$IFNDEF LocalMAX}
        ANSI : BEGIN
                 SendStr(St + #13#10);
                 DisplayANSIstr(St + #13#10);
               END;
{$ENDIF}
        MAX  : MaxCommand(St);
      END;
    END;
    IF AllCaps(St) = #1#1 + Screen THEN BEGIN
      IF (NOT Local) AND (Graphics = MAX) THEN DVWrite(2,24,15,PadRight('Sending Screen Data In: ' + Screen,' ',78));
      Start := TRUE;
    END;
{$IFNDEF LocalMAX}
    IF NOT Carrier THEN BEGIN
      CLOSE(F);
      ShowCursor;
      ErrLevel := 3;
      HALT(ErrLevel);
    END;
{$ENDIF}
  END;
  CLOSE(F);
{$IFNDEF LocalMAX}
  CurColor := TextAttr;
  ShowCursor;
{$ENDIF}
END;

FUNCTION MaxFilter(InString : STRING) : STRING;
VAR
  A      : BYTE;
  B      : BYTE;
  S      : STRING[2];
  Phrase : STRING[2];
PROCEDURE StripIt;
BEGIN
  IF POS(Phrase,InString) > 0 THEN BEGIN
    A := LENGTH(Phrase);
    REPEAT
      B := POS(Phrase,InString);
      S := PadRight('?','?',A);
      DELETE(InString,B,A);
      INSERT(S,InString,B);
    UNTIL POS(Phrase,InString) = 0;
  END;
END;
BEGIN
  Phrase    := '!|'; StripIt;
  Phrase    := '|*'; StripIt;
  Phrase    := '|#'; StripIt;
  Phrase    := '()'; StripIt;
  Phrase    := '';  StripIt;
  MaxFilter := InString;
END;

FUNCTION GetOneField : STRING;
VAR
  FText : TEXT;
  Ch    : CHAR;
  St    : STRING;
BEGIN
  St := '';
  FErase('FIELDS.' + IntToStr(DoorSys.Node));
  REPEAT Ch := sReadKey UNTIL Ch = #24;
  WHILE DataAvailable DO GetChar;
  MaxCommand(#255#126#250#255);
  IF FExist('FIELDS.' + IntToStr(DoorSys.Node)) THEN BEGIN
    ASSIGN(FText,'FIELDS.' + IntToStr(DoorSys.Node));
    RESET(FText);
    WHILE NOT EOF(FText) DO BEGIN
      READLN(FText,St);
      St := StripBoth(St,' ');
    END;
    CLOSE(FText);
    ERASE(FText);
  END;
  WHILE DataAvailable DO GetChar;
  GetOneField := MaxFilter(St);
END;

FUNCTION ChatMessage(Number : BYTE) : STRING;
VAR
  Txt : TEXT;
  Cnt : BYTE;
  St  : STRING;
BEGIN
  ASSIGN(Txt,'CHATMSGS.TXT');
  RESET(Txt);
  Cnt := 0;
  St  := '';
  WHILE NOT EOF(Txt) DO BEGIN
    INC(Cnt);
    READLN(Txt,St);
    IF Cnt = Number THEN BEGIN
      CLOSE(Txt);
      IF Number = 1 THEN St := St + IntToStr(DoorSys.Node) + '!!!';
      ChatMessage := St;
      EXIT;
    END;
  END;
  CLOSE(Txt);
  ChatMessage := '';
END;

PROCEDURE ShowNewMessage;
VAR
  Loop  : BYTE;
  FG1   : BYTE;
  FG2   : BYTE;
  SvgaY : WORD;
BEGIN
  IF Graphics = MAX THEN BEGIN
    MaxCommand('');
    MaxCommand('~');
    MaxCommand('~1,116,637,349,246');
    SvgaY := 120;
  END;
  FOR Loop := 1 TO 14 DO BEGIN
    M^[Loop].UserName := M^[Loop + 1].UserName;
    M^[Loop].Message  := M^[Loop + 1].Message;
    M^[Loop].Channel  := M^[Loop + 1].Channel;
  END;
  M^[15].UserName := Chat.UserName;
  M^[15].Message  := Chat.Message;
  M^[15].Channel  := Chat.Channel;
  FOR Loop := 1 TO 15 DO BEGIN
    IF Graphics <> MAX THEN BEGIN
{$IFNDEF LocalMAX}
      IF M^[Loop].UserName = Name THEN BEGIN
        FG1 := 5;
        FG2 := 13;
      END ELSE BEGIN
        FG1 := 3;
        FG2 := 11;
      END;
{$ENDIF}
    END ELSE BEGIN
      IF M^[Loop].UserName = Name THEN BEGIN
        FG1 := 5;
        FG2 := 4;
      END ELSE BEGIN
        FG1 := 1;
        FG2 := 0;
      END;
    END;
    IF Graphics <> MAX THEN BEGIN
{$IFNDEF LocalMAX}
      IF M^[Loop].Channel = Chan THEN BEGIN
        sGotoXY(1,6 + Loop);
        OutTxt(FG1,0,PadLeft(M^[Loop].UserName,' ',30) + ': ');
        OutTxt(FG2,0,PadRight(M^[Loop].Message,' ',45));
      END ELSE BEGIN
        sGotoXY(1,6 + Loop);
        OutTxt(0,0,PadRight(' ',' ',79));
      END;
{$ENDIF}
    END ELSE BEGIN
      IF M^[Loop].Channel = Chan THEN BEGIN
        MaxCommand('~5,' + IntToStr(SvgaY) + ',' + IntToStr(FG1) + ',3,' + #39 +
        PadLeft(M^[Loop].UserName,' ',30) + ': ' + '{' + IntToStr(FG2) + '}' + M^[Loop].Message + #39 + '');
      END;
      INC(SvgaY,15);
    END;
  END;
  IF Graphics = MAX THEN BEGIN
    MaxCommand('~');
    MaxCommand('~');
    MaxCommand('');
  END;
END;

PROCEDURE ScanChatFile;
VAR
  ChatDat : FILE OF Chat_File;
  Loop    : INTEGER;
  S100    : WORD;
BEGIN
  ASSIGN(ChatDat,'MAXCHAT.DAT');
  RESET(ChatDat);
  FOR Loop := 0 TO (FILESIZE(ChatDat) - 1) DO BEGIN
    SEEK(ChatDat,Loop);
    READ(ChatDat,Chat);
    IF Chat.Node <> DoorSys.Node THEN BEGIN
      IF (Chat.Flags[DoorSys.Node] = 0) AND (Chat.Online) THEN BEGIN
        ShowNewMessage;
        Chat.Flags[DoorSys.Node] := 1;
        SEEK(ChatDat,Loop);
        WRITE(ChatDat,Chat);
{$IFNDEF LocalMAX}
        IF Graphics <> MAX THEN sGotoXY(26 + LENGTH(Msg),23);
{$ENDIF}
      END;
    END;
  END;
  CLOSE(ChatDat);
  WITH CurTime DO GETTIME(Hour,Min,Sec,S100);
  IF Last <> CurTime.Sec THEN BEGIN
    Last := CurTime.Sec;
    UpdateTime;
  END;
END;

PROCEDURE SendMessage;
VAR
  ChatDat : FILE OF Chat_File;
  Loop    : BYTE;
BEGIN
  ASSIGN(ChatDat,'MAXCHAT.DAT');
  IF NOT FExist('MAXCHAT.DAT') THEN BEGIN
    REWRITE(ChatDat);
    FILLCHAR(Chat,SIZEOF(Chat),0);
    Chat.UserName := Name;
    Chat.Online   := Online;
    Chat.Message  := MaxFilter(Msg);
    Chat.Channel  := Chan;
    Chat.Node     := DoorSys.Node;
    Chat.Flags[DoorSys.Node] := 1;
    SEEK(ChatDat,FILESIZE(ChatDat));
    WRITE(ChatDat,Chat);
    CLOSE(ChatDat);
    ShowNewMessage;
    EXIT;
  END ELSE BEGIN
    RESET(ChatDat);
    FOR Loop := 0 TO (FILESIZE(ChatDat) - 1) DO BEGIN
      SEEK(ChatDat,Loop);
      READ(ChatDat,Chat);
      IF Chat.Node = DoorSys.Node THEN BEGIN
        FILLCHAR(Chat,SIZEOF(Chat),0);
        Chat.UserName := Name;
        Chat.Online   := Online;
        Chat.Message  := MaxFilter(Msg);
        Chat.Channel  := Chan;
        Chat.Node     := DoorSys.Node;
        Chat.Flags[DoorSys.Node] := 1;
        SEEK(ChatDat,Loop);
        WRITE(ChatDat,Chat);
        CLOSE(ChatDat);
        ShowNewMessage;
        EXIT;
      END;
    END;
  END;
  FILLCHAR(Chat,SIZEOF(Chat),0);
  Chat.UserName := Name;
  Chat.Online   := Online;
  Chat.Message  := MaxFilter(Msg);
  Chat.Channel  := Chan;
  Chat.Node     := DoorSys.Node;
  Chat.Flags[DoorSys.Node] := 1;
  SEEK(ChatDat,FILESIZE(ChatDat));
  WRITE(ChatDat,Chat);
  CLOSE(ChatDat);
  ShowNewMessage;
END;

PROCEDURE DrawChatScreen;
BEGIN
  Insert1 := IntToStr(Chan);
  IF Graphics <> MAX THEN BEGIN
{$IFNDEF LocalMAX}
    Set_Color(7,0);
    sClrScr;
    SystemScreen('FULLCHAT');
    sGotoXY(1,5);
    SystemScreen('CHANNEL1');
    sGotoXY(25,23);
    OutTxt(CS.Bfg,CS.Fbg,'[                                             ]');
{$ENDIF}
  END ELSE BEGIN
    SystemScreen('FULLCHAT');
    MaxCommand('~0');
    MaxCommand('~');
  END;
  FILLCHAR(M^,SIZEOF(M^),0);
END;

PROCEDURE ChangeChannel;
VAR
  NewCh : INTEGER;
BEGIN
  Insert1 := IntToStr(Chan);
  IF Graphics <> MAX THEN BEGIN
{$IFNDEF LocalMAX}
    Set_Color(7,0);
    sGotoXY(1,23);
    sClrEol;
    SystemScreen('CHANNEL2');
    sGotoXY(43,23);
    NewCh := StrToInt(NumberPrompt(3,IntToStr(Chan)));
{$ENDIF}
  END ELSE BEGIN
    SystemScreen('CHANNEL2');
    NewCh := StrToInt(GetOneField);
  END;
  IF (NewCh > 0) AND (NewCh < 1000) THEN BEGIN
    Msg := ChatMessage(2);
    SendMessage;
    Chan := NewCh;
    DrawChatScreen;
    Msg := ChatMessage(1);
    SendMessage;
  END ELSE DrawChatScreen;
END;

PROCEDURE ShowUsers;
VAR
  ChatDat : FILE OF Chat_File;
  R       : BYTE;
  SvgaY   : WORD;
  Ch      : CHAR;
PROCEDURE TheHeader;
VAR
  Loop : BYTE;
BEGIN
  IF Graphics <> MAX THEN BEGIN
{$IFNDEF LocalMAX}
    Set_Color(7,0);
    FOR Loop := 1 TO 15 DO BEGIN
      sGotoXY(1,6 + Loop);
      sClrEol;
    END;
    sGotoXY(1,7);
{$ENDIF}
  END ELSE BEGIN
    INC(SvgaY,30);
    MaxCommand('~');
    MaxCommand('~1,116,637,349,246');
  END;
  SystemScreen('CHATBAR');
  IF Graphics = MAX THEN MaxCommand('~');
END;
BEGIN
  IF Graphics <> MAX THEN BEGIN
{$IFNDEF LocalMAX}
    Set_Color(7,0);
    sGotoXY(1,23);
    sClrEol;
{$ENDIF}
  END ELSE BEGIN
    SystemScreen('CHATLIST');
    MaxCommand('~0');
  END;
  ASSIGN(ChatDat,'MAXCHAT.DAT');
  RESET(ChatDat);
  R     := 8;
  SvgaY := 120;
  TheHeader;
  WHILE NOT EOF(ChatDat) DO BEGIN
    INC(R);
    READ(ChatDat,Chat);
    IF R <= 21 THEN BEGIN
      IF NOT Chat.Online THEN Chat.UserName := 'No Caller / Caller Busy';
      IF Graphics <> MAX THEN BEGIN
{$IFNDEF LocalMAX}
        sGotoXY(2,R);
        IceText(PadRight(Chat.UserName,' ',31) + PadRight(IntToStr(Chat.Node),' ',29) + IntToStr(Chat.Channel),FALSE);
{$ENDIF}
      END ELSE BEGIN
        MaxCommand('~5,' + IntToStr(SvgaY) + ',5,3,' + #39 + ' ' + PadRight(Chat.UserName,' ',31) +
        PadRight(IntToStr(Chat.Node),' ',29) + IntToStr(Chat.Channel) + #39 + '');
        INC(SvgaY,15)
      END;
    END ELSE BEGIN
      IF Graphics <> MAX THEN BEGIN
{$IFNDEF LocalMAX}
        sGotoXY(2,23);
        CPrompt('C','ontinue');
        CPrompt('Q','uit');
{$ENDIF}
      END ELSE BEGIN
        MaxCommand('~');
        MaxCommand('~');
      END;
      REPEAT Ch := UPCASE(sReadKey) UNTIL Ch IN [#13,'C','Q'];
      IF Ch = 'Q' THEN BEGIN
        CLOSE(ChatDat);
        DrawChatScreen;
        EXIT;
      END;
{$IFNDEF LocalMAX}
      IF Graphics <> MAX THEN BEGIN
        Set_Color(7,0);
        sGotoXY(2,23);
        sClrEol;
      END;
{$ENDIF}
      R     := 8;
      SvgaY := 120;
      TheHeader;
    END;
  END;
  CLOSE(ChatDat);
  IF Graphics <> MAX THEN BEGIN
{$IFNDEF LocalMAX}
    Set_Color(7,0);
    sGotoXY(2,23);
    sClrEol;
    AnyKey;
{$ENDIF}
  END ELSE BEGIN
    MaxCommand('~');
    MaxCommand('~');
    sReadKey;
  END;
  DrawChatScreen;
END;

PROCEDURE RunChatMode;
VAR
  F    : TEXT;
  Ch   : CHAR;
  MM   : STRING[3];
  Loop : BYTE;
BEGIN
  NEW(M);
  Msg    := ChatMessage(1);
  OnLine := TRUE;
  Chan   := 1;
  Last   := CurTime.Sec;
  FILLCHAR(Chat,SIZEOF(Chat),0);
{$IFNDEF LocalMAX}
  IF Graphics = RIP THEN BEGIN
    RipToText;
    Graphics := ANSI;
  END;
{$ENDIF}
  DrawChatScreen;
  SendMessage;
  Msg := '';
  MM  := '';
  IF Graphics <> MAX THEN BEGIN
{$IFNDEF LocalMAX}
    sGotoXY(26,23);
    REPEAT
      IF sKeyPressed THEN BEGIN
        Ch := sReadKey;
        CASE Ch OF
          #0  : MM := s_ReadKey;
          #27 : IF NOT DoorSys.LocalKey THEN BEGIN
                  MM := Ch + sReadKey + sReadKey;
                  Ch := #0;
                END;
        END;
        FOR Loop := Tty TO Ansi DO BEGIN
          IF MM = CursorMove.Up[Loop] THEN MM := '' ELSE
          IF MM = CursorMove.Down[Loop] THEN MM := '' ELSE
          IF MM = CursorMove.Left[Loop] THEN MM := '' ELSE
          IF MM = CursorMove.Right[Loop] THEN MM := '' ELSE
          IF MM = CursorMove.INSERT[Loop] THEN MM := '' ELSE
          IF MM = CursorMove.DELETE[Loop] THEN MM := '' ELSE
          IF MM = CursorMove.Home[Loop] THEN MM := '' ELSE
          IF MM = CursorMove.EndKey[Loop] THEN MM := '';
        END;
        IF (LENGTH(Msg) < 45) AND (Ch > #31) THEN Msg := Msg + Ch;
        IF (LENGTH(Msg) = 45) THEN Ch := #13;
        IF (LENGTH(Msg) > 0) AND (Ch = #8) THEN DELETE(Msg,LENGTH(Msg),1);
        IF (LENGTH(Msg) > 0) AND (Ch = #13) THEN BEGIN
          IF AllCaps(Msg) = '/W' THEN ShowUsers;
          IF AllCaps(Msg) = '/C' THEN BEGIN
            ChangeChannel;
            Msg := '/C';
          END;
          IF AllCaps(Msg) = '/R' THEN DrawChatScreen;
          IF (AllCaps(Msg) <> '/C') AND
             (AllCaps(Msg) <> '/W') AND
             (AllCaps(Msg) <> '/R') AND
             (AllCaps(Msg) <> '/Q') THEN SendMessage;
          sGotoXY(26,23);
          OutTxt(CS.Ffg,CS.Fbg,PadRight(' ',' ',45));
          IF AllCaps(Msg) <> '/Q' THEN Msg := '';
        END;
        IF Ch = #8 THEN BEGIN
          sGotoXY(26,23);
          OutTxt(CS.Ffg,CS.Fbg,PadRight(Msg,' ',45))
        END ELSE IF Ch > #31 THEN BEGIN
          sGotoXY(26 + LENGTH(Msg) - 1,23);
          OutTxt(CS.Ffg,CS.Fbg,Ch);
        END;
        sGotoXY(26 + LENGTH(Msg),23);
      END ELSE ScanChatFile;
    UNTIL (Ch = #13) AND (AllCaps(Msg) = '/Q');
{$ENDIF}
  END ELSE BEGIN
    REPEAT
      Ch := #0;
      IF sKeyPressed THEN Ch := sReadKey ELSE ScanChatFile;
      IF Ch = #31 THEN BEGIN
        WHILE DataAvailable DO GetChar;
        MaxCommand(#255#126#250#255);
        IF FExist('FIELDS.' + IntToStr(DoorSys.Node)) THEN BEGIN
          ASSIGN(F,'FIELDS.' + IntToStr(DoorSys.Node));
          RESET(F);
          WHILE NOT EOF(F) DO BEGIN
            READLN(F,Msg);
            Msg := MaxFilter(StripBoth(Msg,' '));
          END;
          CLOSE(F);
          ERASE(F);
        END;
        WHILE DataAvailable DO GetChar;
{$IFNDEF LocalMAX}
        DVWrite(1,1,14,PadRight('Message: ' + Msg,' ',78));
{$ENDIF}
        MaxCommand('');
        MaxCommand('~1,' + #39#39 + '');
        MaxCommand('~1');
        MaxCommand('~');
        IF AllCaps(Msg) = '/W' THEN ShowUsers;
        IF AllCaps(Msg) = '/C' THEN BEGIN
          ChangeChannel;
          Msg := '/C';
        END;
        IF AllCaps(Msg) = '/R' THEN DrawChatScreen;
        IF (AllCaps(Msg) <> '/C') AND
           (AllCaps(Msg) <> '/W') AND
           (AllCaps(Msg) <> '/R') AND
           (AllCaps(Msg) <> '/Q') AND (Msg <> '') THEN SendMessage;
        IF AllCaps(Msg) <> '/Q' THEN Msg := '';
      END;
    UNTIL AllCaps(Msg) = '/Q';
  END;
  Msg := ChatMessage(3);
  SendMessage;
{$IFNDEF LocalMAX}
  IF Graphics <> MAX THEN sGotoXY(26,23);
{$ENDIF}
  Wait(2);
  Msg    := '';
  OnLine := FALSE;
  Chan   := 1;
  SendMessage;
  DISPOSE(M);
END;

PROCEDURE StartUp;
VAR
  Ch : CHAR;
  St : STRING;
BEGIN
  CS.CPBfg := 8;
  CS.CPKfg := 15;
  CS.CPTfg := 11;
  Name     := DoorSys.UserName;
  Insert1  := Name;
{$IFNDEF LocalMAX}
  IF Local THEN BEGIN
    ShowProgramAd;
    sGotoXY(1,6);
    InfoText('Select Emulation');
    sWriteln('');
    LineBar(1,0,24);
    CPrompt('A',' Local ANSI Graphics');
    sWriteln('');
    CPrompt('M',' Local MAX Graphics');
    sWriteln('');
    CPrompt('Q',' Quit, I''m Confused');
    sWriteln('');
    LineBar(1,0,24);
    sWrite(' ');
    FancyPrompt;
    REPEAT Ch := UPCASE(sReadKey) UNTIL Ch IN ['A','M','Q'];
    OutTxt(15,0,Ch);
    CASE Ch OF
      'M' : BEGIN
              sWriteln('');
              sWriteln('');
              IceText(' Enter Path To ICON_LIB.* Files: ',FALSE);
              St := NoPath(StripBoth(CapsPrompt(40,''),' '));
              IF (NOT DExist(St)) OR (St = '') OR
                 (NOT FExist(St + '\ICON_LIB.001')) OR
                 (NOT FExist(St + '\ICON_LIB.002')) OR
                 (NOT FExist(St + '\ICON_LIB.003')) THEN BEGIN
                ErrLevel := 6;
                HALT(ErrLevel);
              END;
              _Execute('_MAXCHAT.EXE',St);
              HALT;
            END;
      'Q' : HALT;
    END;
  END;
{$ENDIF}
  IF Graphics <> MAX THEN BEGIN
    ShowProgramAd;
    sGotoXY(1,7);
    SystemScreen('LOGON');
    sGotoXY(28,7);
    Name := NamePrompt(30,Name);
  END ELSE BEGIN
    SystemScreen('LOGON');
    Name := GetOneField;
  END;
  Name := StripBoth(Name,' ');
  IF Name = '' THEN HALT ELSE RunChatMode;
END;

END.
